/*

Was kann man noch mit dem System anstellen ?

Software :

Spannungen aller Akkus messen und Anzeigen
Strme messen und Anzeigen
Ladezustandsanzeigen programmieren
Geschwindigkeit, Weg und Beschleunigung messen
Rckspeisen in die Akkus beim Bremsen
Aktive Drehzahlregelung

Hardware :

Bordmonitor bauen (schnes buntes Display)
Mechanische Anschlge fr die Lenkung vorsehen
Automatische Riemenspanner vorsehen
Stabilere Riemen einbauen fr aktive Bremsung / Rckspeisung


<a href="http://www.sprachnudel.de/woerterbuch/rumgurken">rumgurken</a>
<a href="http://konjugator.reverso.net/konjugation-deutsch-verb-rumgurken.html">rumgurken</a>

*/

/*********************************
 *
 * Rumgurke 1.0 aka Fahrtregler
 *
 *********************************/

#include	<pic18.h>
#include 	<string.h>
#include	<ctype.h>
#include	<math.h>
#include	<stdlib.h>
#include	<stdio.h>
#include  "defines.h"                                     // globale Definitionen
#include  "serial.h"                                      // UART-Funktionen

#define	XTAL_FREQ	4MHZ
#define	MHZ	*1000

#define	DelayUs(x)	{ unsigned int _dcnt; \
			  _dcnt = (x)/(12MHZ/(XTAL_FREQ))|1; \
			  while(--_dcnt != 0) \
				  continue; }

/********************
 *
 * Globale Variablen
 *
 ********************/

// Allgemeines
volatile unsigned long Timerticks = 0;                    // Systemticker
volatile int Sekundenticker1 = 0;                         // Steuerung ISR-Intern
volatile int Sekundenticker2 = 0;                         // Steuerung ISR-Intern
char buf [80];                                            // Ausgabepuffer

// Drehzahlen
volatile unsigned int DrehzahlRechts = 0;
volatile unsigned int DrehzahlLinks = 0;
volatile char LinksFehlerFlag = FALSE;
volatile char RechtsFehlerFlag = FALSE;

// Joystick
unsigned int JoystickX [JoystickPufferZeigerMax];
unsigned int JoystickY [JoystickPufferZeigerMax];
char JoystickPufferZeiger = 0;

// Strom
volatile unsigned int StromLinks = 0;
volatile unsigned int StromRechts = 0;

// Lenkwinkel
volatile int Lenkwinkel = 0;
char RichtungsFlag = FALSE;
char RichtungsFlagAlt = TRUE;
char Erststart = TRUE;

// Drehzahlregelung
volatile int RegelTicker = 0;
volatile int RegelTickerAlt = 0;

long DrehzahlAbweichungLinks;
long DrehzahlAbweichungRechts;

int StellgroesseLinks = 0;
int StellgroesseRechts = 0;

float Kp = 0.08;																						// Verstrkung Proportional

char DebugausGabenFlag = FALSE;
char UARTReady = FALSE;

//-------------------------------------------------
// Konfiguration des Controllers
//-------------------------------------------------
__CONFIG(1, OSCEN & HSPLL);                               // Quarz * 4 => 40Mhz
__CONFIG(2, BORDIS & WDTDIS);                             // Kein Watchdog, BrownOut 4.2V
__CONFIG(4, LVPDIS & STVREN);                             // Kein LowVoltageProgramm, Reset bei StackOverflow

/***********************
 *
 * Systemticker erhhen
 *
 ***********************/
void Systemticker (void)
 {
  Timerticks++;
 }

/************************
 *
 * Systemticker auslesen
 *
 ************************/
long Get_Ticker (void)
 {
  return (Timerticks);
 }

/**************************************
 *
 * Verzgern im Millisekundenbereich
 *
 **************************************/
void Delayms (unsigned int time)
 {
  long ticker;

  ticker = Get_Ticker ();
  while ( (ticker + (time )) > Get_Ticker () );
 }

/***************************
 *
 * Wandlerwert reinlutschen
 *
 ***************************/
unsigned int ADCGetRaw (char channel)
 {
  //-----------------
  // Wo solls rein ?
  //-----------------
  if (channel & 0b100) CHS2 = 1; else CHS2 = 0;
  if (channel & 0b010) CHS1 = 1; else CHS1 = 0;
  if (channel & 0b001) CHS0 = 1; else CHS0 = 0;
  DelayUs (300);  // Kondensator laden
  GODONE = 1;     // Los gehts
  while (GODONE);

  return (ADRES);
 }

/**************************************
 *
 * Wie gehts denn dem Freudenspender ?
 *
 **************************************/
void GetJoystick (void)
 {
  JoystickX [JoystickPufferZeiger] = ADCGetRaw (0);
  JoystickY [JoystickPufferZeiger] = ADCGetRaw (1);
  JoystickPufferZeiger++;
  if (JoystickPufferZeiger == JoystickPufferZeigerMax) JoystickPufferZeiger = 0;
 }

/****************************************************
 *
 * Genehmigt sich der Mller Elektronen oder nicht ?
 *
 ****************************************************/
void GetStrom (void)
 {
  StromLinks = ADCGetRaw (2);
  StromRechts = ADCGetRaw (4);
 }

/**********************
 *
 * Wo gehts denn hin ?
 *
 **********************/
void GetLenkwinkel (void)
 {
  Lenkwinkel = ADCGetRaw (5);
 }

/**************************************
 *
 * Wie gehts denn dem Freudenspender ?
 *
 **************************************/
int GetJoystickX (void)
 {
  #define JoystickXMax 1023           // Ganz aussen
  #define JoystickXMin   0           // Ganz aussen
  #define JoystickXNull 500           // Mittelstellung

  #define MaxPosX        20           // Auszugebender Wertebereich +/-
  #define JoystickHysterese	50				// Hysterese um den Nullpunkt

  #define mXPlus = (float)(JoystickXMax - JoystickXNull) / MaxPosX;    // Steigung der Geraden
  #define mXMinus = (float)(JoystickXMin - JoystickXNull) / MaxPosX;   // Steigung der Geraden

  char i;
  int temp = 0;
  int RetWert = 0;

  float test;

  // Schwimmenden Mittelwert des Rohdatenpuffers bilden
  for (i=0; i < JoystickPufferZeigerMax; i++)
   temp +=  JoystickX [i];
 temp /= JoystickPufferZeigerMax;

 // ber oder unter Null ?
 if (temp > (JoystickXNull+JoystickHysterese))
  {
    test = temp - JoystickXNull;      // Auf Null Normieren
    test = test / mXMinus;
    RetWert = (int)test;
    RetWert *= -1;
  } else

 if (temp < (JoystickXNull-JoystickHysterese))
  {
   test = temp - JoystickXNull;      // Auf Null Normieren
   test = test / mXPlus;
   RetWert = (int)test;
  } else RetWert = 0;

  return (RetWert);

 }

/**************************************
 *
 * Wie gehts denn dem Freudenspender ?
 *
 **************************************/
int GetJoystickY (void)
 {
  #define JoystickYMin 1023           // Ganz Aussen
  #define JoystickYMax    0           // Ganz Aussen
  #define JoystickYNull 500           // Mittelstellung

  #define MaxPosY        20           // Auszugebender Wertebereich +/-

  #define mYPlus = (float)(JoystickYMax - JoystickYNull) / MaxPosY;   // Steigung der Geraden
  #define mYMinus = (float)(JoystickYMin - JoystickYNull) / MaxPosY;  // Steigung der Geraden

  char i;
  int temp = 0;
  int RetWert = 0;

  float test;

  // Schwimmenden Mittelwert des Rohdatenpuffers bilden
  for (i=0; i < JoystickPufferZeigerMax; i++)
   temp +=  JoystickY [i];
 temp /= JoystickPufferZeigerMax;

  // ber oder unter Null ?
 if (temp > (JoystickYNull+JoystickHysterese))
  {
    test = temp - JoystickYNull;      // Auf Null Normieren
    test = test / mYMinus;
    RetWert = (int)test;
  } else

 if (temp < (JoystickXNull-JoystickHysterese))
  {
   test = temp - JoystickYNull;      // Auf Null Normieren
   test = test / mYPlus;
   RetWert = (int)test;
   RetWert *= -1;
  } else RetWert = 0;

  return (RetWert);

 }

/***********************
 *
 * Linken Motor steuern
 *
 ***********************/
void SetMotorLinks (int Sollwert)
 {

  if (Sollwert > 0)
   {
    // Linkslauf
    BL_Links = 1;
    AL_Links = 0;
    AH_Links = 1;
    BH_Links = 0;
    DebugausGabenFlag = FALSE;
   }

  if (Sollwert < 0)
   {
    // Rechtslauf
    BL_Links = 0;
    AL_Links = 1;
    AH_Links = 0;
    BH_Links = 1;
    DebugausGabenFlag = FALSE;
   }

 if (abs (Sollwert) >=250) Sollwert = 255;

 CCPR2 = abs (Sollwert);     // PWM Linker Kanal

  // Aus
 if (Sollwert == 0)
  {
   // Links bremsen
   BL_Links = 1;
   AL_Links = 1;
   AH_Links = 0;
   BH_Links = 0;

   // Rechts bremsen
   BL_Rechts = 1;
   AL_Rechts = 1;
   AH_Rechts = 0;
   BH_Rechts = 0;

   // Eventuell wieder abschalten wenn Rder stehen

   CCPR2 = 255;   // Transistoren voll durchschalten

   if ((!DebugausGabenFlag) && (UARTReady) )
    {
     DebugausGabenFlag = TRUE;
     print ("Brems du Sau!");  // Grunz
    }

  }

 }

/************************
 *
 * Rechten Motor steuern
 *
 *******************+****/
void SetMotorRechts (int Sollwert)
 {

  if (Sollwert > 0)
   {
    // Linkslauf
    BL_Rechts = 1;
    AL_Rechts = 0;
    BH_Rechts = 0;
    AH_Rechts = 1;
   }

  if (Sollwert < 0)
   {
    // Rechtslauf
    BL_Rechts = 0;
    AL_Rechts = 1;
    BH_Rechts = 1;
    AH_Rechts = 0;
   }

 CCPR1 = abs (Sollwert);     // PWM Rechter Kanal

  // Aus
 if (Sollwert == 0)
  {
   BL_Rechts = 1;
   AL_Rechts = 1;
   BH_Rechts = 0;
   AH_Rechts = 0;

   // Eventuell abschalten wenn Rder stehen

   CCPR1 = 255;
  }

 }


/*****************
 *
 * Zentrale ISR
 *
 *****************/
interrupt void INT_ (void)
 {

   //--------------------
   // Timer 0 berlauf ?
   //--------------------
   if (TMR0IF)
   	{

      Systemticker ();                                  // Systemticker erhhen, siehe MISC.C

      RegelTicker++;																	  // Zur Steuerung des PID-Reglers

      TMR0IF=0;                                         // Clear Interrupt-Flag
      TMR0L=0x96;                                       // Timer 0 neu vorladen (0xE796 = 10ms @ 20Mhz, 5ms @ 40Mhz)
      TMR0H=0xE7;                                       // n = 2^16 - t [s] * 625000

      //-----------------------
      // Ablauf 20* pro Sekunde
      //-----------------------
      Sekundenticker2++;
      if (Sekundenticker2 > 10)
       {
        GetLenkwinkel ();                               // Lenkwinkel messen
        Sekundenticker2 = 0;
       }

      //-----------------------
      // Ablauf 5* pro Sekunde
      //-----------------------
      Sekundenticker1++;
      if (Sekundenticker1 > 40)
       {
        GetJoystick ();                               // Joystickposition messen
        GetStrom ();                                  // Stromaufnahme messen
        Sekundenticker1 = 0;
       }

   	} // From Timer 0 berlauf

   //------------------------
   // Drehzahlmessung Links
   //------------------------

   //--------------------------
   // Interrupt Lichtschranke
   //--------------------------
   if (INT0IF)
    {
     if (!LinksFehlerFlag) DrehzahlLinks = 65535-TMR1;       // Timerinhalt bernehmen
     LinksFehlerFlag = FALSE;
     TMR1ON = 0;                                       // Timer kurz anhalten
     TMR1H = 0;                                        // Timer wieder auf 0 stellen
     TMR1L = 0;                                        // Timer wieder auf 0 stellen
     TMR1ON = 1;                                       // Und weiter gehts
     INT0IF = 0;
    }

   //--------------------------------
   // Interrupt zugehriger Timer
   // berlauf ohne Input alle 26ms
   //--------------------------------
   if (TMR1IF)
    {
     DrehzahlLinks = 0;                               // Timer ist bergelaufen, da dreht nix
     TMR1IF = 0;
     LinksFehlerFlag = TRUE;
    }

   //------------------------
   // Drehzahlmessung Rechts
   //------------------------

   //--------------------------
   // Interrupt Lichtschranke
   //--------------------------
   if (INT1IF)
    {
     if (!RechtsFehlerFlag) DrehzahlRechts = 65535-TMR3;                             // Timerinhalt bernehmen
     RechtsFehlerFlag = FALSE;
     TMR3H = 0;                                         // Timer wieder auf 0 stellen
     TMR3L = 0;                                         // Timer wieder auf 0 stellen
     INT1IF = 0;
     if (RB5) RB5=0; else RB5=1;                      // An RB5 klappern
    }

   //--------------------------------
   // Interrupt zugehriger Timer
   // berlauf ohne Input alle 26ms
   //--------------------------------
   if (TMR3IF)
    {
     DrehzahlRechts = 0;                                // Timer ist bergelaufen, da dreht nix
     TMR3IF = 0;
     RechtsFehlerFlag = TRUE;
     if (RB4) RB4=0; else RB4=1;                      // An RB4 klappern
     TMR3IF = 0;
    }

   //-----------------
   // USART-Interrupt
   //-----------------
   isr_usart ();

   return;									                            // Zurck zum Hauptprogramm
 }

/*****************************
 *
 * Globale Initialisierungen
 *
 *****************************/
void Init (void)
 {

  //-----------
  // Port-Init
  //-----------

  PORTA=0;
  PORTB=0;
  PORTC=0;
  PORTD=0;
  PORTE=0;

  TRISA = 0xFF;
  TRISB = 0b11001111;
  TRISC = 0b11100111;
  TRISD = 0;
  TRISE |= 0b00000011;

  RC3 = 0;
  RC4 = 0;

  //------------
  // Timer-Init
  //------------

  //--------------------------
  // Timer 0 macht Systemtakt
  //--------------------------
  T08BIT = 0;     // 16-Bit-Modus
  T0CS = 0;       // Interner Takt
  PSA = 1;        // Kein Prescaler
  TMR0IE=1;				// enable Interrupt of TMR0
  TMR0IF=0;       // Clear Interrupt-Flag
  TMR0L=0x96;     // Timer 0 neu vorladen (0xE796 = 10ms @ 20Mhz, 5ms @ 40Mhz)
  TMR0H=0xE7;     // n = 2^16 - t [s] * 625000
  TMR0ON = 1;     // Timer 0 an

  //----------------------------------
  // Timer 1 ermittelt Drehzahl links
  // Freilaufend und antiautoritr
  //----------------------------------
  RD16 = 1;       // 16 Bit
  T1CKPS1 = 1;    // Prescaler 1:4
  T1CKPS0 = 0;
  T1OSCEN = 0;    // Kein Oszillator
  TMR1CS = 0;     // Interner Takt
  TMR1 = 0;       // Alles auf 0
  TMR1ON = 1;     // Lauf los

  //-----------------------------------
  // Timer 3 ermittelt Drehzahl Rechts
  // Freilaufend und antiautoritr
  //-----------------------------------
  T3RD16 = 1;     // 16 Bit
  T3CKPS1 = 1;    // Prescaler 1:4
  T3CKPS0 = 0;
  TMR3CS = 0;     // Interner Takt
  TMR3 = 0;       // Alles auf 0
  TMR3ON = 1;     // Lauf Los

  //--------------------------------------
  // Timer 2 macht PWM fr Motorsteuerung
  //--------------------------------------
  TOUTPS3 = 1;    // 1:16 Postscaler
  TOUTPS2 = 1;
  TOUTPS1 = 1;
  TOUTPS0 = 1;
  T2CKPS1 = 1;    // 1:16 Prescaler
  PR2 = 0XFF;     // Periodenregister setzen

  TMR2ON = 1;     // Und los

  //---------------------
  // PWM startklar machen
  //---------------------
  // Links
  CCPR1L = 0;             // Peridodendauer 0
  DC1B1 = 0;
  DC1B0 = 0;
  CCP1M3 = 1;             // PWM-Modus
  CCP1M2 = 1;             // PWM-Modus
  TRISC &= ~0b00000010;   // Als Ausgang deklarieren

  // Rechts
  CCPR2L = 0;            // Peridodendauer 0
  DC2B1 = 0;
  DC2B0 = 0;
  CCP2M3 = 1;            // PWM-Modus
  CCP2M2 = 1;            // PWM-Modus
  TRISC &= ~0b00000100;  // Als Ausgang deklarieren

  //--------------------------
  // Lichtschranken startklar
  //--------------------------
  INTEDG0 = 1;           // Interrupt auf steigender Flanke
  INTEDG1 = 1;           // Interrupt auf steigender Flanke

  TMR1IE =  1;           // Interrupts der Timer bei berlauf

  INT0IE = 1;            // Links. Externe Interrupts der Lichtschranken
  // INT1IE = 1;            // Rechts. Externe Interrupts der Lichtschranken

  //---------------
  // Interrupts an
  //---------------
  PEIE=1;          			 // Peripherie Int=on
  GIE=1;								 // Define Interupts

  //----------------
  // PWM einrichten
  //----------------
  SetMotorLinks (0);
  SetMotorRechts (0);

  //-----------------
  // UART klarmachen
  //-----------------
  UART_Init ();          // UART initialisieren
  UARTReady = TRUE;

  //--------------------------
  // AD-Wandler-Einstellungen
  //--------------------------
  ADCS2 = 1;            // Wandlertakt Fosc/64
  ADCS1 = 1;
  ADCS0 = 0;
  ADON = 1;             // Wandler ein
  ADFM = 1;             // Rechtsseitig

  PCFG3 = 0;            // Externe Referenz, alle Kanle Analog
  PCFG2 = 0;
  PCFG1 = 0;
  PCFG0 = 1;

  //---------------
  // Sag mal Huhu!
  //---------------
  sprintf (buf, "\n\rRumgurke V1.0 startklar\n\r");
  print (buf);

 }

/****************************************************************
 *
 * Macht die Lenkbewegung in Abhngigkeit von Joystickposition
 *
 ****************************************************************/
void Lenkung (void)
 {
  int RichtungSoll;
  int RichtungIst;
  char Flag;

  // Soll- und Istdaten reinholen
  RichtungSoll = GetJoystickX ()*25;    // Skaliert auf -500..+500
  RichtungIst = Lenkwinkel-512;   		  // Skaliert auf -500..+500

  // Grenzbereiche anpassen
  if (RichtungSoll > 500) RichtungSoll = 500;
  if (RichtungSoll < -500) RichtungSoll = -500;
  if (RichtungIst > 500) RichtungIst = 500;
  if (RichtungIst < -500) RichtungIst = -500;

  // Servo bei zu groer Abweichung einschalten
  if ((abs (RichtungSoll-RichtungIst)) > 30) Flag = 1; else Flag = 0;
  RC4 = Flag;

  // Richtung festlegen (Schaltet Polwender sofern Motor eingeschaltet werden soll)
  if (Flag)
   if (RichtungIst > RichtungSoll) RichtungsFlag = 1; else RichtungsFlag = 0;

  // Ist die Drehrichtung anders herum als vorher ?
  if (Erststart)
   {
    RichtungsFlagAlt = ~RichtungsFlag;
    Erststart = FALSE;
   }

  if (RichtungsFlag != RichtungsFlagAlt)
   {

    RichtungsFlagAlt = RichtungsFlag;
    if (Flag)
     {
       RC4 = 0;             // Motor aus
       Delayms (200);       // Warten bis Stillstand
       if (RichtungsFlag) RC3 = 1; else RC3 = 0;

       Delayms (200);			  //	Warten bis stabil
       RC4 = 1;             // Motor wieder ein
     }
   }

 }

/*********
 *
 * Main
 *
 *********/
void main (void)
{
  int i;
  int Drehzahlsollwert = 0;
  int DrehzahlsollwertAlt = 0;
  int Drehdampf  = 0;
  int IstDrehdampf = 0;
  unsigned long Ticks = 0;                    // Systemticker

  // Beschleunigungsrampen
  #define Pause 1

  Init ();

  // Startphase
  sprintf (buf, "RCON : %d\n\r", RCON);
  print (buf);
  RCON = 0;
  for (i=0; i < 20; i++)
   {
    print (".");
    Delayms (100);
    GetJoystickX ();
   }
  print ("\n\rRumgurke startklar!\n\r");
  i = 0;

  while (1)
   {
    // Steuerung der Lenkung Asynchron zum Geschehen
    Lenkung ();

    // Regler Synchron
    if (RegelTickerAlt != RegelTicker)
     {
      // Regelalgorythmus

      //--------------------
      // Sollwert bestimmen
      //--------------------
      Drehzahlsollwert = GetJoystickY ();   // +-20
      Drehzahlsollwert = Drehzahlsollwert *100;

      //----------------------
      // Abweichung bestimmen
      //----------------------

      // Links
      DrehzahlAbweichungLinks = (long)Drehzahlsollwert - (long)DrehzahlLinks;
      if (DrehzahlAbweichungLinks < 0) DrehzahlAbweichungLinks = 0;

      // Rechts
      DrehzahlAbweichungRechts = (long)Drehzahlsollwert - (long)DrehzahlRechts;
      if (DrehzahlAbweichungRechts < 0) DrehzahlAbweichungRechts = 0;

      //----------------------
      // Stellgre berechnen
      //----------------------

      // Links
      StellgroesseLinks = (int)((float)DrehzahlAbweichungLinks * Kp);     // Proportionalregler
      if (StellgroesseLinks > 255) StellgroesseLinks = 255;								// Maximalwert begrenzen

      // Rechts
      StellgroesseRechts = (int)((float)DrehzahlAbweichungRechts * Kp);   // Proportionalregler
      if (StellgroesseRechts > 255) StellgroesseRechts = 255;             // Maximalwert begrenzen

      //---------------------
      // Stellgre ausgeben
      //---------------------
      sprintf (buf, "S:%5d A:%5d I:%5d\n\r", Drehzahlsollwert, DrehzahlsollwertAlt, IstDrehdampf);
      print (buf);

      // berwachung auf pltzlichen Lastwechsel
      if ( ( (Drehzahlsollwert >= 0) && (DrehzahlsollwertAlt < 0) ) ||
           ( (Drehzahlsollwert <  0) && (DrehzahlsollwertAlt >= 0) ) )
       {
        print ("Lastwechsel\n\r");
        if (( (DrehzahlLinks > 0) || (DrehzahlRechts > 0) ))
         {
          print ("Zwischenbremse\n\r");
          Drehdampf = 0;
         } else DrehzahlsollwertAlt = Drehzahlsollwert;

       } else
       {
        DrehzahlsollwertAlt = Drehzahlsollwert;
        Drehdampf = Drehzahlsollwert;
       }

      //---------------------------
      // Motoren endlich ansteuern
      //---------------------------

      // Mistkacke, Knoten+Bier im Hirn

      // Beschleunigungsrampen realisieren

      // Fahren wir vorwrts ?
      if (Drehdampf >=0)
       {
        if (Drehdampf > IstDrehdampf) { if (Ticks+Pause < Timerticks) { Ticks = Timerticks; IstDrehdampf+=10; } } else
         IstDrehdampf = Drehdampf;
       } else

       // ? strwkcR riw nerhaf redO
       {
        if (Drehdampf < IstDrehdampf) { if (Ticks+Pause < Timerticks) { Ticks = Timerticks; IstDrehdampf-=10; } } else
         IstDrehdampf = Drehdampf;
       } // Von else if (Drehdampf >=0)

      SetMotorLinks  (IstDrehdampf / 8);
      SetMotorRechts (IstDrehdampf / 8);

  	  Delayms (100);

      RegelTickerAlt = RegelTicker;
     } // Von if (RegelTickerAlt != RegelTicker)

   } // Von while (1)

}

// Thats all folks !





